package com.bull.cimero.pluginEditor.editors.parts;

import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.ConnectionEditPart;

import com.bull.cimero.pluginEditor.editors.figure.GeneriqueCimeroFigure;
import com.bull.cimero.pluginEditor.editors.figure.SEFigure.WireTapFigure;
import com.bull.cimero.pluginEditor.editors.model.Connection;
import com.bull.cimero.pluginEditor.editors.model.Diagram;

/**
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class WireTapPart extends GeneriqueCimeroPart {

	/**
	 * constructor from super class.
	 * @param diagramParam : the diagram part.
	 * @param bShow : true if the log must to be show.
	 */
	public WireTapPart(final Diagram diagramParam, final boolean bShow) {
		super(diagramParam, bShow, "");
	}

	/**
	 * @see com.bull.cimero.pluginEditor.editors.parts
	 * .GeneriqueCimeroPart#getCimeroFigure()
	 * @return the figure using by this part.
	 */
	protected final IFigure getCimeroFigure() {
		return new WireTapFigure();
	}

	/**
	 * This function is used to return the ConnectionAnchor of the source
	 * element when the user selected the object.
	 * @param connection : the connection
	 * @return ConnectionAnchor : the anchor
	 */
	public final ConnectionAnchor getSourceConnectionAnchor(
			final ConnectionEditPart connection) {
		//get the wireTap element.
		Connection myConn = (Connection)
					((ConnectionPart) connection).getModel();
		boolean typeConnection = myConn.isSourceBottom();
		ConnectionAnchor cc = null;
		if (typeConnection) {
			cc = ((GeneriqueCimeroFigure) getFigure())
							.getConnectionAnchor("outputcopy");
		} else {
			cc = ((GeneriqueCimeroFigure) getFigure())
							.getConnectionAnchor("output");
		}
		return cc;
	}

}
