package com.bull.cimero.pluginEditor.editors.partsOutline;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import com.bull.cimero.pluginEditor.editors.model.Diagram;
import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;

/**
 * class used to make communication for content model and outline view.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class TreePartFactory implements EditPartFactory {

	 /**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart
	 * (org.eclipse.gef.EditPart, java.lang.Object)
	 * create the part that make the binding beetween the cimero view and
	 * the outline view.
	 * @param context : the contect.
	 * @param model : the model of the cimero view.
	 * @return the reference to the outline view
	 */
	public final EditPart createEditPart(final EditPart context,
												final Object model) {
      if (model instanceof Diagram) {
         return new DiagramTreeEditPart(model);
      } else if (model instanceof GeneriqueCimeroModel) {
         return new NodeTreeEditPart(model);
      } else {
         return null;
      }
   }

}
