package com.bull.cimero.pluginEditor.editors.policies;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.SelectionEditPolicy;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.osgi.baseadaptor.HookConfigurator;
import org.eclipse.swt.widgets.Menu;

import com.bull.cimero.pluginEditor.editors.model.Diagram;
import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;
import com.bull.cimero.pluginEditor.popupMenu.ContextPopupMenu;

/**
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class NodeSelectionEditPolicy extends SelectionEditPolicy {

	
	/**
	 *
	 */

	/**
	 * constructor.
	 * @param viewerP : the arent viewer.
	 */
	public NodeSelectionEditPolicy(final EditPartViewer viewerP) {
		super();
		
	}

	/**
	 * @see org.eclipse.gef.editpolicies.SelectionEditPolicy#hideSelection()
	 *remove the context menu of this element.
	 */
	protected final void hideSelection() {
		GeneriqueCimeroModel model = getPartModel();
		if ((model != null) && (model.getDiagram() != null)){
			model.getDiagram().setCurrentSelectedNode(null);
		}else{
			System.out.println("Node SelectionPolicy :: showSelection model is null");
		}
	}

	/**
	 * @see org.eclipse.gef.editpolicies.SelectionEditPolicy#showSelection()
	 * we use this function to create the context menu that presents
	 * the selected part.
	 */
	protected final void showSelection() {
		GeneriqueCimeroModel model = getPartModel();
		if ((model != null) && (model.getDiagram() != null)){
			System.out.println("Selected End Point ["+ model.getName()+ "]");
			model.getDiagram().setCurrentSelectedNode(model.getName());
		}else{
			System.out.println("Node SelectionPolicy :: showSelection model is null");
		}
	}

	/**
	 * get part model.
	 * @return generiqueCImeroModel of this part
	 */
	protected final GeneriqueCimeroModel getPartModel() {
		return (GeneriqueCimeroModel) (
				(GraphicalEditPart) getHost()).getModel();
	}

	

	
}
