package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.factory.standardFactory.SE;

import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;
import com.bull.cimero.pluginEditor.editors.model.SEModel.Pipeline;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.lWFactory.GeneriqueLWfactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.NameSpaceClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardEIPPipelineClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardJBIClass;

/**
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class PipelineFactory extends StandardEIPFactory {

	/**The suffixe to the http component.*/
	public static final String HTTPSUFFIXE = "Http";

	/**
	 * default constructor.
	 * @param nms : the namespace using by this factory.
	 */
	public PipelineFactory(final NameSpaceClass nms) {
		super(nms);
	}

	/**
	 * @see com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.standardFactory.GeneriqueStandardFactory
	 * #createJBIElement(com.bull.cimero.pluginEditor.editors.model
	 * .GeneriqueCimeroModel)
	 * create the JBIElement.
	 * @param elt : the pipeline element.
	 * @return the standard JBI element created.
	 * @throws Exception if the generation return an error.
	 */
	public final StandardJBIClass createJBIElement(
			final GeneriqueCimeroModel elt)
			throws Exception {
		StandardEIPPipelineClass myPipelineSM = null;
		if (elt instanceof Pipeline) {
			Pipeline myPipeline = (Pipeline) elt;
			//get the destination element.
			GeneriqueCimeroModel destElt = getDestination(elt);
			if (destElt != null) {
				NameSpaceClass destinationNms = getNamespace(destElt);
				myPipelineSM = new StandardEIPPipelineClass(
						myPipeline.getName(),
						new NameSpaceClass(GeneriqueLWfactory.NAMESPACENAME,
										GeneriqueLWfactory.NAMESPACEVALUE),
						myPipeline.getName(),
						new NameSpaceClass(getNamespaceName(),
								  getNamespaceValue()),
						myPipeline.getName() + HTTPSUFFIXE,
						new NameSpaceClass(GeneriqueLWfactory.NAMESPACENAME,
								GeneriqueLWfactory.NAMESPACEVALUE),
								destElt.getName(),
								destinationNms);

			}  else {
				throw new Exception("The destination component of the "
					+ elt.getName() + " object doesn't exist");
			}
		} else {
			throw new Exception("the object : "
			  + elt.getName() + " hasn't a good type for this factory");
		}
		return myPipelineSM;
	}

}
