package com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory
	.standardFactory.SE;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.bull.cimero.pluginEditor.editors.model.Connection;
import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;
import com.bull.cimero.pluginEditor.editors.model.SEModel.RecipientList;
import com.bull.cimero.pluginEditor.editors.model.SEModel.Routeur;
import com.bull.cimero.pluginEditor.editors.model.SEModel.Splitter;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.lWFactory.GeneriqueLWfactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.ActivationSpecClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.ComponentClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.StandardComponentClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardEIPRecipientList;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardEIPSplitter;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardJBIClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardRouterClass;

/**
 * The Splitter factory.
 * @author Cedric Mouilleron
 * @author Pierre Notel
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class RecipientListFactory extends StandardEIPFactory {
	/**
	 * default constructor.
	 * @param nms : the namespace using by this factory.
	 */
	public RecipientListFactory(final NameSpaceClass nms) {
		super(nms);
	}
	
	public final List<GeneriqueCimeroModel> getDestinations(
			final GeneriqueCimeroModel elt) {
		
		List<GeneriqueCimeroModel> destinations = new ArrayList<GeneriqueCimeroModel>();
		GeneriqueCimeroModel destElt = null;
		if (elt.getOutgoingConnections().size() != 0) {
			for (Iterator it = elt.getOutgoingConnections().iterator(); it.hasNext();){
				Connection modelTmp = (Connection)it.next();
				if (modelTmp != null) {
					destElt = modelTmp.getTarget();
					destinations.add(destElt);
				}
			}
		}
		return destinations;
	}
	public StandardJBIClass createJBIElement(GeneriqueCimeroModel elt)
			throws Exception {
	
			StandardEIPRecipientList  myRecipientListSM = null;
			if (elt instanceof RecipientList) {
				RecipientList myRecipientList = (RecipientList) elt;
				//get the destination element.
				
				
				Map<String, NameSpaceClass> destinationMap  = new HashMap<String, NameSpaceClass>();
				List<GeneriqueCimeroModel> destinations = getDestinations(elt);
				
				for (GeneriqueCimeroModel destEl : destinations){
					destinationMap.put(destEl.getName(), getNamespace(destEl));
				}
				if (destinationMap.size() > 0){
					
					myRecipientListSM = new StandardEIPRecipientList(
							myRecipientList.getName(),
							new NameSpaceClass(GeneriqueLWfactory.NAMESPACENAME,GeneriqueLWfactory.NAMESPACEVALUE),
							new NameSpaceClass(getNamespaceName(), getNamespaceValue()),
							myRecipientList.getName(),
							destinationMap);
				} else {
					throw new Exception("The destination component of the "
							+ elt.getName() + " object doesn't exist");
				}
			} else {
				throw new Exception("the object : "
						+ elt.getName() + " hasn't a good type for this factory");
			}
			return myRecipientListSM;
		}

	
}
