package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.factory.standardFactory;

import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardJBIClass;

/**
 * This interface presents the standard components in ServiceMix.
 *
 * @author Cedric Mouilleron
 * @author Pierre Notel
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public interface StandardComponentFactory {

	/**
	 * Return the standard model of the cimero component in parameter.
	 * @param elt : the cimero component .
	 * @return the standard component presents the cimero component.
	 * @throws Exception if the generation failed.
	 */
	StandardJBIClass createJBIElement(GeneriqueCimeroModel elt)
				throws Exception;
}
