package com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation.StandardJBIClass;

/**
 * This class represents a standardComponent in the ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class StandardComponentClass {
	/**The namespace reference of this component.*/
	private NameSpaceClass namespaceReference = null;
	/**The reference to the standardComponentJBI.*/
	private StandardJBIClass myJBICompo = null;

	/**
	 * constructor.
	 * @param nms : the namespace of this component.
	 */
	public StandardComponentClass(final NameSpaceClass nms) {
		this.namespaceReference = nms;
	}
	/**
	 * @return Returns the standardJBI componentn.
	 */
	public final StandardJBIClass getMyJBICompo() {
		return myJBICompo;
	}

	/**
	 * @param myJBICompoParam : The myJBICompo to set.
	 */
	public final void setMyJBICompo(final StandardJBIClass myJBICompoParam) {
		this.myJBICompo = myJBICompoParam;
	}

	/**
	 * @return Returns the namespaceReference.
	 */
	public final NameSpaceClass getNamespaceReference() {
		return namespaceReference;
	}

	/**
	 * @param namespaceReferenceParam The namespaceReference to set.
	 */
	public final void setNamespaceReference(
			final NameSpaceClass namespaceReferenceParam) {
		this.namespaceReference = namespaceReferenceParam;
	}
}
