package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class represents the EIP pipeline in the ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class StandardEIPPipelineClass extends StandardJBIClass implements IServiceEngineClass {


	/**The transformeur service name.*/
	private String transformeurServiceName = "";
	/**The namespace using by this transformeur.*/
	private NameSpaceClass trsfNamespace = null;
	/**the target service name.*/
	private String targetServiceName = "";
	/**The namespace using by this target.*/
	private NameSpaceClass targetNamespace = null;


	/**
	 * The constructor with parameter.
	 * @param srcName : the name of the service
	 * @param srcNamespace : the namespace using by this service
	 * @param endpointParam : the nedpoint value
	 * @param jBINamespace : the namespace using by this component
	 * @param trfsServiceName : the trsf service name
	 * @param trsfNamespaceParam : the namespace using by the transformeur.
	 * @param trgServiceName : the target name
	 * @param trgNamespace : the target namespace
	 */
	public StandardEIPPipelineClass(final String srcName,
			final NameSpaceClass srcNamespace,
			final String endpointParam,
			final NameSpaceClass jBINamespace,
			final String trfsServiceName,
			final NameSpaceClass trsfNamespaceParam,
			final String trgServiceName,
			final NameSpaceClass trgNamespace) {
		super(jBINamespace);
		this.serviceName = srcName;
	
		this.serviceNamespace = srcNamespace;
		this.endpointValue = endpointParam;
		this.transformeurServiceName = trfsServiceName;
		this.trsfNamespace = trsfNamespaceParam;
		this.targetServiceName = trgServiceName;
		this.targetNamespace = trgNamespace;
	}
	
	/**
	 * @return Returns the serviceName.
	 */
	public final String getServiceName() {
		return serviceName;
	}
	/**
	 * @return Returns the targetNamespace.
	 */
	public final NameSpaceClass getTargetNamespace() {
		return targetNamespace;
	}
	/**
	 * @return Returns the targetServiceName.
	 */
	public final String getTargetServiceName() {
		return targetServiceName;
	}
	/**
	 * @return Returns the transformeurServiceName.
	 */
	public final String getTransformeurServiceName() {
		return transformeurServiceName;
	}
	/**
	 * @return Returns the trsfNamespace.
	 */
	public final NameSpaceClass getTrsfNamespace() {
		return trsfNamespace;
	}
	
	
	@Override
	public List<PropertyModel> getPropertiesToStore() {
		
		List<PropertyModel> propertiesToStore = new ArrayList<PropertyModel>();
		
		return propertiesToStore;
	}


}
