package com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.bull.cimero.pluginEditor.editors.model.BCModel.JdbcBC;
import com.bull.cimero.pluginEditor.editors.model.SEModel.RecipientList;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.lWFactory.GeneriqueLWfactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

public class StandardEIPRecipientList extends StandardJBIClass implements IServiceEngineClass {
	
	private RecipientList recList = null;
	Map<String, NameSpaceClass> destinationMap = null;
	
	public StandardEIPRecipientList( 
		final String srcName,
		final NameSpaceClass serviceNamespaceParam,
		final NameSpaceClass jBINamespace,
		final String endPValue,
		final Map<String, NameSpaceClass> destinationMap
		) {
		super(jBINamespace);
		this.serviceNamespace = serviceNamespaceParam;
		this.serviceName = srcName;
		this.endpointValue = endPValue;
		this.destinationMap = destinationMap;
	}
	
	@Override
	public List<PropertyModel> getPropertiesToStore() {
		// TODO Auto-generated method stub
		return new ArrayList<PropertyModel>();
	}
	
	public String getXBean(){
		StringBuffer sb = new StringBuffer();
		
		sb.append("<eip:static-recipient-list service=\""+ GeneriqueLWfactory.NAMESPACENAME+ ":"
				+ this.endpointValue +"\" endpoint=\""+ this.endpointValue+"\">\n");
		sb.append("  <eip:recipients>\n");
		
		NameSpaceClass nsClass = null;
		for (String destName : destinationMap.keySet()){
			nsClass = destinationMap.get(destName);
			sb.append("<eip:exchange-target service=\""+nsClass.getNameSpaceName()+":"+ destName+ "\"/>\n");
		}
			

		
		sb.append("</eip:recipients>\n");
		sb.append("</eip:static-recipient-list>\n");
		return sb.toString();
	}

}
