package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class is a generique standard JBI component in the
 * ServiceMix model. All the standard servicemix component
 *  extend this class.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public abstract class StandardJBIClass {


	/**The namespace reference using by this JBi component.*/
	private NameSpaceClass namespaceRef = null;
	/**The service destination name.*/
	protected String serviceName = "";
	/**The namespace using by the service.*/
	protected NameSpaceClass serviceNamespace = null;
	/**the value of the endpoint.*/
	protected String endpointValue = "";

	public final NameSpaceClass getServiceNamespace() {
		return serviceNamespace;
	}
	/**
	 * default constructor.
	 * @param nms : the namespace using by this JBI Component.
	 */
	public StandardJBIClass(final NameSpaceClass nms) {
		super();
		this.namespaceRef = nms;
	}

	/**
	 * @return Returns the namespaceRef.
	 */
	public final NameSpaceClass getNamespaceRef() {
		return namespaceRef;
	}
	
	public final String getEndpointValue() {
		return endpointValue;
	}
	
	public abstract List<PropertyModel> getPropertiesToStore();
	
	public static PropertyModel createPropertyModel(String propName, String propValue){
		PropertyModel prop = new PropertyModel();
		prop.setName(propName);
		prop.setValue(propValue);
		return prop;
	}
}
