package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.xmlModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.IModelServiceMix;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.ActivationSpecClass;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.NameSpaceClass;

/**
 * This class is the top level of the Xml ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class ContainerClass implements IModelServiceMix {

	/** the ServiceMix namespace name.*/
	private NameSpaceClass nameSpaceUse;
	/** This list contain all the namespace using in ServiceMix.*/
	private List < NameSpaceClass > lstNameSpace = null;
	/** This list contain all the activation spec.*/
	private List < ActivationSpecClass > lstActivationSpec = null;


	/**
	 * default constructor.
	 */
	public ContainerClass() {
		super();
		//initialise the list
		lstNameSpace = new ArrayList < NameSpaceClass >();
		lstActivationSpec = new ArrayList < ActivationSpecClass >();
	}

	/**
	 * add a namespace.
	 * @param elt : the namespace object
	 * @return true if the insertion is ok
	 */
	public final boolean addNameSpace(final NameSpaceClass elt) {
		return lstNameSpace.add(elt);
	}

	/**
	 * add an ActivationSpec.
	 * @param elt : the ActivationSpec object
	 * @return true if the insertion is ok
	 */
	public final boolean addActivationSpec(final ActivationSpecClass elt) {
		return lstActivationSpec.add(elt);
	}

	/**
	 * @return the using namespace.
	 */
	public final NameSpaceClass getNameSpaceType() {
		return nameSpaceUse;
	}

	/**
	 * @param nameSpaceParam : the selected namespace.
	 */
	public final void setNameSpaceType(final NameSpaceClass nameSpaceParam) {
		this.nameSpaceUse = nameSpaceParam;
	}

	/**
	 * @return the ActivationSpec list.
	 */
	public final List < ActivationSpecClass > getLstActivationSpec() {
		return lstActivationSpec;
	}

	/**
	 * @return the nameSpace list.
	 */
	public final List < NameSpaceClass > getLstNameSpace() {
		return lstNameSpace;
	}
}
