package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.AttributeContentProvider;
import it.eng.cimero.plugin.providers.AttributeLabelProvider;
import it.eng.cimero.plugin.providers.ClassificationLabelProvider;
import it.eng.cimero.plugin.providers.RulesContentProvider;
import it.eng.cimero.plugin.providers.RulesLabelProvider;
import it.eng.cimero.plugin.providers.ServiceAssemblyContentProvider;
import it.eng.cimero.plugin.providers.ServiceAssemblyLabelProvider;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.Attribute;
import it.eng.spagosoa.metadb.model.AttributeCatalog;
import it.eng.spagosoa.metadb.model.IterType;
import it.eng.spagosoa.metadb.model.IterTypeServiceAssembly;
import it.eng.spagosoa.metadb.model.IterTypeServiceAssemblyId;
import it.eng.spagosoa.metadb.model.Rule;
import it.eng.spagosoa.metadb.model.ServiceAssembly;
import it.eng.utils.DialogUtils;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.ISelectionListener;
import org.hibernate.HibernateException;

import cimeroEditor.CimeroEditorPlugin;

public class DetailIterTypeDialog extends TitleAreaDialog {

    private Composite aComposite = null;
    private CLabel iterTypeNameLabel = null;
    private Text iterTypeNameTextField = null;
    
    private CLabel iterTypeDescriptionLabel = null;
    private Text iterTypeDescriptionTextField = null;
    
   
    private List<ServiceAssembly> serviceAssemblies = null;
    
    private CLabel ruleExpressionLabel = null;
    private Text ruleExpressionTextArea = null;
    
    
    private IterType iterType = null;
    private SashForm internalSash  = null; 
    
    private SashForm sashServiceAssemblies  = null;
    private SashForm sashAttributes  = null;
    private SashForm sashRuleIterType  = null;
    
    private Table tableServiceAssemblyForIterType = null;
    private TableViewer tbvServiceAssemblyForIterType = null;
    
    private Table tableAttributesForIterType = null;
    private TableViewer tbvAttributesForIterType = null;
    
    private IMetadbApi metadb = null;
    
    private Button btnAddSA = null;
    private Button btnUpSA = null;
    private Button btnDownSA = null;
    private Button btnChooseAttribute = null;
	
    private boolean newIter = true;
    
    public DetailIterTypeDialog( Shell parentShell,  IMetadbApi metadb) {
		
		super(parentShell);
		this.metadb = metadb;
		this.metadb.openTx();
		this.newIter = true;
		
	}
    public DetailIterTypeDialog( Shell parentShell, IterType iterType, IMetadbApi metadb) {
		
		super(parentShell);
		this.iterType = iterType;
		this.metadb = metadb;
		this.metadb.openTx();
		this.iterType = (IterType)metadb.getObjectById(IterType.class, iterType.getIdIterType());
		this.newIter = false;
		
	}
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
	    setTitle(" Iter Type Dialog ");
	    if (iterType != null)
	    	setMessage("Iter Type "+ iterType.getName() + " Configuration "); 
	   
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       
		aComposite = new Composite(internalSash, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 4;
    	aComposite.setLayout(layout);
    	
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	//    	 Riga 1
    	iterTypeNameLabel = new CLabel(aComposite, SWT.RIGHT);
    	iterTypeNameLabel.setText(" Iter Type Name ");
    	
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 3;
    	iterTypeNameTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	iterTypeNameTextField.setLayoutData(data);
    	iterTypeNameTextField.setText((iterType != null ? iterType.getName() : ""));
    	if (iterType != null){
    		
    		iterTypeNameTextField.setEditable(false);
    	
    	}
    
    	
    	//    	 Riga 2
    	iterTypeDescriptionLabel = new CLabel(aComposite, SWT.RIGHT);
    	iterTypeDescriptionLabel.setText(" Description ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 3;
    	
    	iterTypeDescriptionTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	iterTypeDescriptionTextField.setLayoutData(data);
    	iterTypeDescriptionTextField.setText((iterType != null ? iterType.getDescription() : ""));
    	
	
    	// Sash Service Assembly
    	this.serviceAssemblies = getServiceAssemblies();
    	
    	this.sashServiceAssemblies = new SashForm(internalSash,  SWT.VERTICAL | SWT.FLAT);
    	
    	Composite compositeSA = new Composite(sashServiceAssemblies, SWT.NONE);
		final GridLayout layoutcompositeSA = new GridLayout();
		layoutcompositeSA.marginWidth = 15;
		layoutcompositeSA.marginHeight = 10;
		layoutcompositeSA.numColumns = 7;
    	compositeSA.setLayout(layoutcompositeSA);
    	
    	CLabel configureSALabel  = new CLabel(compositeSA, SWT.LEFT);
    	configureSALabel.setText(" Configure Processes for Iter type ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 2;
    	configureSALabel.setLayoutData(data);
    	
    	btnAddSA = new Button(compositeSA, SWT.PUSH);
    	//btnAddSA.setText(" Select Process ");
    	String imgPath = "icons" + File.separator + "add.png";
    	Image addImage = CimeroEditorPlugin.getImageDescriptor(
				imgPath).createImage();
    	btnAddSA.setImage(addImage);
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 1;
    	btnAddSA.setLayoutData(data);
    	
    	btnUpSA = new Button(compositeSA, SWT.PUSH);
    	//btnUpSA.setText(" Move up selected process ");
    	imgPath = "icons" + File.separator + "arrow_up.png";
    	Image upImage = CimeroEditorPlugin.getImageDescriptor(
				imgPath).createImage();
    	btnUpSA.setImage(upImage);
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 1;
    	btnUpSA.setLayoutData(data);
    	
    	btnDownSA = new Button(compositeSA, SWT.PUSH);
    	//btnDownSA.setText(" Move down selected process ");
    	imgPath = "icons" + File.separator + "arrow_down.png";
    	Image downImage = CimeroEditorPlugin.getImageDescriptor(
				imgPath).createImage();
    	btnDownSA.setImage(downImage);
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 1;
    	btnDownSA.setLayoutData(data);
    	
    	CLabel filler = new CLabel(compositeSA, SWT.LEFT);
    	filler.setText("           ");
    	data.horizontalSpan = 2;
    	filler.setLayoutData(data);
    	
    	btnAddSA.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				if (checkSaveIterType()){
					ListServiceAssemblyDialog saListDialog = new ListServiceAssemblyDialog(getShell(), metadb, true, "Add Business Process to Iter Type ");
					saListDialog.open();
				
					ServiceAssembly aServiceAssembly = saListDialog.getSelectedSA();
					if (aServiceAssembly != null){
						saveIterTypeSARelation(aServiceAssembly);
						tbvServiceAssemblyForIterType.setInput(getServiceAssembliesForIterType());
						tbvServiceAssemblyForIterType.refresh(true);
					}
					
				}
			}

			public void widgetSelected(SelectionEvent e) {
				widgetDefaultSelected(e);
				
			}
    	});
    	
    	btnUpSA.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				 
				int selectionIndex = tableServiceAssemblyForIterType.getSelectionIndex();
				
				int itemCount = tableServiceAssemblyForIterType.getItemCount();
				//DialogUtils.warning(getShell(), "Selection["+selectionIndex+"] ItemCount ["+itemCount+"]");
				if (selectionIndex > -1 ){
					if (selectionIndex > 0 ){
						TableItem selected = tableServiceAssemblyForIterType.getItem(selectionIndex);
						TableItem prev = tableServiceAssemblyForIterType.getItem(selectionIndex - 1);
						
						if ((selected != null) && (prev != null)){
							swapOrderCriteriaInIterTypeRelation((ServiceAssembly)selected.getData(),(ServiceAssembly)prev.getData());
							tbvServiceAssemblyForIterType.setInput(getServiceAssembliesForIterType());
							tbvServiceAssemblyForIterType.refresh(true);
						}
					}else{
						DialogUtils.warning(getShell(), " Cannot move up this process. It's the first ");
					}
						
				}else{
					DialogUtils.warning(getShell(), " No Process Selected ");
				}
			}

			public void widgetSelected(SelectionEvent e) {
				widgetDefaultSelected(e);
				
			}
    	});
    	
    	btnDownSA.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				
				int selectionIndex = tableServiceAssemblyForIterType.getSelectionIndex();
				
				int itemCount = tableServiceAssemblyForIterType.getItemCount();
				//DialogUtils.warning(getShell(), "Selection["+selectionIndex+"] ItemCount["+itemCount+"]");
				if (selectionIndex > -1){
					if ( (selectionIndex + 1) != itemCount ){
						TableItem selected = tableServiceAssemblyForIterType.getItem(selectionIndex);
						TableItem next = tableServiceAssemblyForIterType.getItem(selectionIndex + 1);
						
						if ((selected != null) && (next != null)){
							swapOrderCriteriaInIterTypeRelation((ServiceAssembly)selected.getData(),(ServiceAssembly)next.getData());
							tbvServiceAssemblyForIterType.setInput(getServiceAssembliesForIterType());
							tbvServiceAssemblyForIterType.refresh(true);
						}
					}else{
						DialogUtils.warning(getShell(), " Cannot move down this process. It's the last one");
					}
						
				}else{
					DialogUtils.warning(getShell(), " No Process Selected ");
				}
				
				
				
			}

			public void widgetSelected(SelectionEvent e) {
				widgetDefaultSelected(e);
				
			}
    	});
    	
    	
    	//Sash Attributes
    	this.sashAttributes = new SashForm(internalSash,  SWT.VERTICAL | SWT.FLAT);
    	
    	Composite compositeAttributes = new Composite(sashAttributes, SWT.NONE);
		final GridLayout layoutcompositeAttributes = new GridLayout();
		layoutcompositeAttributes.marginWidth = 15;
		layoutcompositeAttributes.marginHeight = 10;
		layoutcompositeAttributes.numColumns = 7;
		compositeAttributes.setLayout(layoutcompositeSA);
    	
    	CLabel configureAttributesLabel  = new CLabel(compositeAttributes, SWT.LEFT);
    	configureAttributesLabel.setText(" Attributes that identify iter ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 2;
    	configureAttributesLabel.setLayoutData(data);
    	
    	btnChooseAttribute = new Button(compositeAttributes, SWT.PUSH);
    	//btnChooseAttribute.setText(" Select Attribute ");
    	btnChooseAttribute.setImage(addImage);
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.horizontalSpan = 1;
    	btnChooseAttribute.setLayoutData(data);
    	
    	
    	btnChooseAttribute.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				if (checkSaveIterType()){
					
					List<Attribute> candidateAttributes = metadb.getCandidateAttributesForIterType(iterType);
					ListAttributesDialog aListAttributesDialog = new ListAttributesDialog(getShell(), metadb, "Add attribute to Service Assembly ", candidateAttributes);
					aListAttributesDialog.open();
				
					Attribute aAttribute = aListAttributesDialog.getSelectedAttribute();
					if (aAttribute != null){
						linkAttributeWithIter(aAttribute);
						tbvAttributesForIterType.setInput(getAttributesForIterType());
						tbvAttributesForIterType.refresh(true);
					}
				}
			}

			public void widgetSelected(SelectionEvent e) {
				widgetDefaultSelected(e);
				
			}
    	});
    	
    	filler = new CLabel(compositeSA, SWT.LEFT);
    	filler.setText("           ");
    	data.horizontalSpan = 4;
    	filler.setLayoutData(data);
    	
    	
    	
    	//    	 Tabella SA
    	this.tableServiceAssemblyForIterType = new Table(sashServiceAssemblies, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableServiceAssemblyForIterType.setLinesVisible(true);
        this.tableServiceAssemblyForIterType.setHeaderVisible(true);
        TableColumn column = null;
 		column = new  TableColumn(tableServiceAssemblyForIterType, SWT.LEFT);
 		column.setText(" Process Name");
 		column.setWidth(200);
 		column = new TableColumn(tableServiceAssemblyForIterType, SWT.LEFT);
 		column.setText(" Process Descritpion");
 		column.setWidth(200);
        this.tbvServiceAssemblyForIterType = new TableViewer(tableServiceAssemblyForIterType);
        tbvServiceAssemblyForIterType.setContentProvider(new ServiceAssemblyContentProvider());
        tbvServiceAssemblyForIterType.setLabelProvider(new ServiceAssemblyLabelProvider());
           
    	if (this.iterType == null){
    		tbvServiceAssemblyForIterType.setInput(new ArrayList());
    	}else{
    		tbvServiceAssemblyForIterType.setInput(getServiceAssembliesForIterType());
    	}
    	
    	
        final DetailIterTypeDialog theDialog = this;
        this.tableServiceAssemblyForIterType.addKeyListener(new KeyListener(){
        	public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
        		System.out.println("KeyCode =" +  e.keyCode);
        		if (e.keyCode == 127){
        			TableItem[] tis = theDialog.tableServiceAssemblyForIterType.getSelection();
        			ServiceAssembly selectedSA = (ServiceAssembly)tis[0].getData();
        			removeIterTypeSARelation(selectedSA);
        			theDialog.tbvServiceAssemblyForIterType.setInput(getServiceAssembliesForIterType());
        			theDialog.tbvServiceAssemblyForIterType.refresh();
        		}
        	};
        	public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
        		
        	};
        	
        });
        
        this.tableAttributesForIterType = new Table(sashAttributes, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableAttributesForIterType.setLinesVisible(true);
        this.tableAttributesForIterType.setHeaderVisible(true);
        
 		column = new  TableColumn(tableAttributesForIterType, SWT.LEFT);
 		column.setText(" Attribute ");
 		column.setWidth(400);
 		
        this.tbvAttributesForIterType = new TableViewer(tableAttributesForIterType);
        tbvAttributesForIterType.setContentProvider(new AttributeContentProvider());
        tbvAttributesForIterType.setLabelProvider(new AttributeLabelProvider());
           
    	
    	tbvAttributesForIterType.setInput(getAttributesForIterType());
    	
        this.tableAttributesForIterType.addKeyListener(new KeyListener(){
        	public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
        		System.out.println("KeyCode =" +  e.keyCode);
        		if (e.keyCode == 127){
        			TableItem[] tis = theDialog.tableAttributesForIterType.getSelection();
        		
        		    Attribute selectedAttribute = (Attribute)tis[0].getData();
        			unlinkAttributeWithIter( selectedAttribute );
        			theDialog.tbvAttributesForIterType.setInput( getAttributesForIterType() );
        			theDialog.tbvAttributesForIterType.refresh();
        		}
        	};
        	public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
        		
        	};
        });

//      Sash Attributes

        this.sashRuleIterType = new SashForm(internalSash,  SWT.VERTICAL | SWT.FLAT);
        Composite ruleExpressionComposite = new Composite(sashRuleIterType, SWT.NONE);
        final GridLayout layoutRuleExprComposite = new GridLayout();
        layoutRuleExprComposite.marginWidth = 15;
        layoutRuleExprComposite.marginHeight = 10;
        layoutRuleExprComposite.numColumns = 10;
    	ruleExpressionComposite.setLayout(layoutRuleExprComposite);
    	
//  	 Rule Expression
    	ruleExpressionLabel = new CLabel(ruleExpressionComposite, SWT.CENTER);
    	ruleExpressionLabel.setText(" Rule for Iter Type Determination ( Boolean XPath Expression ) ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 10;
    	ruleExpressionLabel.setLayoutData(data);
    	
    	
    	ruleExpressionTextArea = new Text(ruleExpressionComposite, SWT.MULTI| SWT.WRAP | SWT.BORDER);
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.heightHint = 50;
    	data.horizontalSpan = 10;
    	ruleExpressionTextArea.setLayoutData(data);
       
    	if (iterType != null){
    		ruleExpressionTextArea.setText(iterType.getRule().getExpr());
    	}
    	
        sashServiceAssemblies.setWeights(new int[]{20, 70});
        sashAttributes.setWeights(new int[]{20, 70});
        
   
    	this.internalSash.setWeights(new int[]{10,25,25,25});
        return parent; 
	
	}
	
	
	
	@Override
	protected void buttonPressed(int buttonId) {
		
		if (buttonId == IDialogConstants.CANCEL_ID){
			this.metadb.rollBackAndClose();
			close();
		}else{
			if (checkSaveIterType()){
				// Le relazioni con i SA e gli attributi sono salvati automaticamente
				// Devo gestire la regola
				String ruleExprText = ruleExpressionTextArea.getText().trim();
				if (ruleExprText.length() == 0){
					DialogUtils.error(
							getShell(),
							"The Rule Expression is required");
					return;
				}
				
				Rule ruleIterTypeDetermination = iterType.getRule();
				
				if (ruleIterTypeDetermination != null){
					ruleIterTypeDetermination.setExpr(ruleExprText);
				}else{
					Integer usage  = DetailRuleDialog.USAGE_ITER_TYPE_DETERMINATION;
					Integer mepState = DetailRuleDialog.MEP_APPLY_IN_OUT;
					ruleIterTypeDetermination = new Rule();
					ruleIterTypeDetermination.setDescription("Rule for the determination of Iter Type["+iterType.getName()+"] ");
					ruleIterTypeDetermination.setRuleUsage(usage);
					ruleIterTypeDetermination.setMepState(mepState);
					ruleIterTypeDetermination.setConditionExpr(null);
					ruleIterTypeDetermination.setExpr(ruleExprText);
					metadb.storeRule(ruleIterTypeDetermination);
					this.iterType.setRule(ruleIterTypeDetermination);
					this.iterType = metadb.storeIterType(iterType);
				}
				this.metadb.commitAndClose();
				close();
			}
		}
	}
		

	public List<ServiceAssembly> getServiceAssembliesForIterType(){
		List<ServiceAssembly> result =  metadb.getServiceAssembliesForIterType(this.iterType);
		return result;
	}
	
	
	
	
	
	
	private boolean saveIterTypeSARelation(ServiceAssembly sa){
			try {
				metadb.linkServiceAssemblyToIterType(sa, iterType);
				return true;

			} catch (RuntimeException t) {
			
				t.printStackTrace();
				return false;
			}
		
		
	}
	
	private boolean removeIterTypeSARelation(ServiceAssembly sa){
			try {
				metadb.unlinkServiceAssemblyIterType(sa,  iterType);
				return true;
			} catch (RuntimeException t) {
				
				t.printStackTrace();
				return false;
			}
	}
	
	public List<ServiceAssembly> getServiceAssemblies(){
			List<ServiceAssembly> result =  metadb.getServiceAssemblies();
			return result;
	}
	
	

	
	
	protected void createButtonsForButtonBar(Composite parent) {
		
		// -- Create OK and Cancel buttons by default
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
				true);
		
		createButton(parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL,
				true);
		
	}
	
	protected List<Attribute> getAttributesForIterType(){
		if (iterType == null){
			return new ArrayList<Attribute>();
		}
		
		List<Attribute> result =  metadb.getAttributesForIterType(iterType);
		
		return result;
	}
	
	protected boolean checkSaveIterType(){
		
		if (iterType == null){
			if (iterTypeNameTextField.getText().trim().length() == 0){
				DialogUtils.error(getShell(), "Specify Iter Type Name");
				return false;
			}
			IterType aIterType = new IterType();
			aIterType.setName(iterTypeNameTextField.getText());
			
			if (iterTypeDescriptionTextField.getText().trim().length() == 0){
				aIterType.setDescription("Description For "+iterTypeNameTextField.getText());
			}else{
				aIterType.setDescription(iterTypeDescriptionTextField.getText().trim());
			}
			try{
				this.iterType = metadb.storeIterType(aIterType);
				return true;
			}catch (RuntimeException e) {
				e.printStackTrace();
				return false;
			}
		}else{
			return true;
		}
	}
	private boolean linkAttributeWithIter(Attribute attribute){
			try {
				metadb.linkAttributeWithIterType(attribute, iterType);
				return true;
			}catch (RuntimeException e) {
				e.printStackTrace();
				return false;
			}
		
	}
	
	private boolean unlinkAttributeWithIter(Attribute attribute){
			try{
				metadb.unlinkAttributeWithIterType(attribute, iterType);
				return true;
			}catch (RuntimeException e) {
				e.printStackTrace();
				return false;
			}
		
	}
	public boolean isNewIter() {
		return newIter;
	}
	public void setNewIter(boolean newIter) {
		this.newIter = newIter;
	}
	
	public void swapOrderCriteriaInIterTypeRelation(ServiceAssembly sa1, ServiceAssembly sa2){
		IterTypeServiceAssemblyId id1 = new IterTypeServiceAssemblyId(sa1.getIdAssembly(), iterType.getIdIterType());
		IterTypeServiceAssemblyId id2 = new IterTypeServiceAssemblyId(sa2.getIdAssembly(), iterType.getIdIterType());
		IterTypeServiceAssembly itSa1 = (IterTypeServiceAssembly)metadb.getObjectById(IterTypeServiceAssembly.class, id1);
		IterTypeServiceAssembly itSa2 = (IterTypeServiceAssembly)metadb.getObjectById(IterTypeServiceAssembly.class, id2);
		
		int order1 = itSa1.getOrderCriteria();
		itSa1.setOrderCriteria(itSa2.getOrderCriteria());
		metadb.genericStore(itSa1);
		itSa2.setOrderCriteria(order1);
		metadb.genericStore(itSa2);
	}
}
