package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.AttributeContentProvider;
import it.eng.cimero.plugin.providers.AttributeLabelProvider;
import it.eng.cimero.plugin.providers.IterTypesContentProvider;
import it.eng.cimero.plugin.providers.IterTypesLabelProvider;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.Attribute;
import it.eng.spagosoa.metadb.model.AttributeCatalog;
import it.eng.spagosoa.metadb.model.IterType;
import it.eng.spagosoa.metadb.model.Rule;
import it.eng.spagosoa.metadb.model.ServiceAssembly;
import it.eng.utils.DialogUtils;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

public class ListAttributesDialog extends TitleAreaDialog {
	
    private Composite aComposite = null;
	
    private SashForm internalSash  = null; 
    
    private Table tableAttribute = null;
    private TableViewer tbvAttribute = null;
    private List<Attribute> listAttribute = null;

   
    private IMetadbApi metadb = null;
  
    public static final int SELECT_ATTRIBUTE_ID = 99003;
    
    private Attribute selectedAttribute = null;
    private String message = null;
    
	public ListAttributesDialog(Shell parentShell, IMetadbApi metadb, String message ) {
		super(parentShell);
		this.metadb = metadb;
	
	}
	
	public ListAttributesDialog(Shell parentShell, IMetadbApi metadb, String message, List<Attribute> providedAttributeList ) {
		super(parentShell);
		this.metadb = metadb;
		this.listAttribute = providedAttributeList;
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
		setTitle("Attributes");
	    if (message != null)
	    	setMessage(message);
	    else
	    	setMessage("Attributes");
	   
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       	
        this.tableAttribute = new Table(internalSash, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableAttribute.setLinesVisible(true);
        this.tableAttribute.setHeaderVisible(true);
        TableColumn column = null;
		column = new TableColumn(tableAttribute, SWT.LEFT);
		column.setText("Name");
		column.setWidth(200);
		column = new TableColumn(tableAttribute, SWT.LEFT);
		column.setText("Type");
		column.setWidth(100);
        this.tbvAttribute = new TableViewer(tableAttribute);
        tbvAttribute.setContentProvider(new AttributeContentProvider());
        tbvAttribute.setLabelProvider(new AttributeLabelProvider());
     
        if (listAttribute == null)
        	listAttribute = getAttributes();
        
        tbvAttribute.setInput(listAttribute);    
        
        final ListAttributesDialog  theDialog = this;
        
        
        this.tableAttribute.addKeyListener(new KeyListener(){
        	public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
        		System.out.println("KeyCode =" +  e.keyCode);
        		
        		/*if (e.keyCode == 127){
        			TableItem[] tis = theDialog.tableAttribute.getSelection();
        			
        			if (tis.length > 0){
        				if (deleteAttribute((Attribute)tis[0].getData())){
        					theDialog.tbvAttribute.setInput(getAttributes());
        					theDialog.tbvAttribute.refresh(true);
        					theDialog.tbvAttribute.refresh();
        				}else{
        					MessageDialog.openError(
        		        			getShell(),
        		        			"Cimero Editor",
        		        			"Cannot delete attribute");
        				}
        			}

        			
        		}
        		*/
        	};
        	public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
        		
        	};
        	
        });
        
        this.tbvAttribute.addSelectionChangedListener(new ISelectionChangedListener(){

			public void selectionChanged(SelectionChangedEvent event) {
				TableItem[] selections = theDialog.tableAttribute.getSelection();
				if (selections.length > 0){
					theDialog.selectedAttribute = (Attribute)selections[0].getData();
					setMessage("Selected Attribute " + theDialog.selectedAttribute.getName());
					
				}
			}
        	
        });
        
        this.tbvAttribute.addDoubleClickListener(new IDoubleClickListener(){
        	
			public void doubleClick(DoubleClickEvent event) {
				TableItem[] selection = tableAttribute.getSelection();
				if ((selection != null) && (selection.length > 0)){
	    			selectedAttribute = (Attribute)((TableItem)selection[0]).getData();
	    			close();
	    		}else{
	    			DialogUtils.information(getShell(), "Select an Attribute to associate to catalog");
	    		}
				
			}
	
        });
        return parent; 
	
	}
	
	protected void okPressed() {
		super.okPressed();
		
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
		if (buttonId == IDialogConstants.CANCEL_ID)
			this.selectedAttribute = null;
		super.buttonPressed(buttonId);
		
	}


	protected void createButtonsForButtonBar(Composite parent) {
		
		
		createButton(parent, IDialogConstants.CANCEL_ID, IDialogConstants.CLOSE_LABEL,
				true);
		
		
	}

	public boolean deleteAttribute(Attribute attribute) {
		try{
			metadb.openTx();
			metadb.deleteAttribue(attribute);
			metadb.commitAndClose();
			return true;
		}catch (Throwable e) {
			e.printStackTrace();
			metadb.rollBackAndClose();
			return false;
		}
	}
	
	public List<Attribute> getAttributes(){
		boolean needToHandleOpenClose = !metadb.isOpen();
		if (needToHandleOpenClose)
			metadb.open();
			List<Attribute> result = metadb.getAttributes();
		if (needToHandleOpenClose)
				metadb.open();
		return result;
	
	}




	public Attribute getSelectedAttribute() {
		return selectedAttribute;
	}




	public void setSelectedAttribute(Attribute selectedAttribute) {
		this.selectedAttribute = selectedAttribute;
	}
	
}
