package it.eng.cimero.plugin.dialogs;

import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.Attribute;
import it.eng.spagosoa.metadb.model.AttributeCatalog;
import it.eng.spagosoa.metadb.model.XmlNamespace;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class NewXMLNamespaceDialog extends TitleAreaDialog {

//	final SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
	

    private Composite aComposite = null;
    private CLabel namespacePrefixLabel = null;
    private Text namespacePrefixText = null;
    
    private CLabel namespaceValueLabel = null;
    private Text namespaceValueTextField = null;
    
    private IMetadbApi metadb = null;
    
    
	public NewXMLNamespaceDialog(Shell parentShell, IMetadbApi metadb) {
		
		super(parentShell);
		this.metadb = metadb;
	
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
	    
	    setTitle("New Namespace");
	    setMessage("New Namespace ");
	    
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        
  
		
		aComposite = new Composite(parent, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 5;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	
    	
    	
    	
    	// Riga 2
    	namespacePrefixLabel = new CLabel(aComposite, SWT.RIGHT);
    	namespacePrefixLabel.setText(" Prefix ");
    	namespacePrefixText = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	namespacePrefixText.setLayoutData(data);
    	
//    	 Riga 2
    	namespaceValueLabel = new CLabel(aComposite, SWT.RIGHT);
    	namespaceValueLabel.setText(" Value ");
    	namespaceValueTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	namespaceValueTextField.setLayoutData(data);
    	
    	
    	
    		
        return parent; 
	
	}
	
	protected void okPressed() {
		
		
		if (namespacePrefixText.getText().trim().length() > 0 
				&& namespaceValueTextField.getText().trim().length() > 0){
			try{
				metadb.openTx();
				
				XmlNamespace xmlNamespace = new XmlNamespace();
			
			
				xmlNamespace.setPrefix(namespacePrefixText.getText());
				xmlNamespace.setValue(namespaceValueTextField.getText());
				metadb.storeXmlNamespace(xmlNamespace);
				metadb.commitAndClose();
	
			}catch (Exception e) {
				e.printStackTrace();
				metadb.rollBackAndClose();
			}
			super.okPressed();
		}else{
			MessageDialog.openError(
					getShell(),
					"CimeroEditor Plug-in",
					"To add a namespace you must set the prefix and the value");
		}
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
		
		super.buttonPressed(buttonId);
	}




	
	
}
