package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.ClassificationContentProvider;
import it.eng.cimero.plugin.providers.ClassificationLabelProvider;
import it.eng.serviceregistry.IServiceRegistry;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.Endpoint;
import it.eng.spagosoa.metadb.model.Property;
import it.eng.spagosoa.metadb.model.ServiceAssembly;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.registry.infomodel.ClassificationScheme;
import javax.xml.registry.infomodel.Organization;
import javax.xml.registry.infomodel.Service;
import javax.xml.registry.infomodel.ServiceBinding;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

import cimeroEditor.CimeroEditorPlugin;

public class PublishServiceRegistryDialog extends TitleAreaDialog {

//	final SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
	

    private Composite aComposite = null;
    private CLabel serviceRegistryNameLabel = null;
    private Text serviceRegistryNameTextField = null;
    
    private CLabel serviceDescriptionLabel = null;
    private Text serviceDescriptionTextField = null;
    
    private CLabel serviceOrganizationLabel = null;
    private Combo aComboOrganizations = null;
    private Combo aComboTaxonomies = null;
    private Combo aComboTaxonomiesValues = null;
    private CLabel serviceClassificationLabel = null;
    
    private List<String> taxonomiesValues = null;
    private String[] aComboTaxonomyValuesItems = null;
	
    private List<String> organizations =null;
    private String[] aComboOrganizationItems = null;
	
    private List<String> taxonomies = CimeroEditorPlugin.getDefault().getTaxonomies();
    private String[] aComboTaxonomyItems = new String[taxonomies.size()];
	
    private SashForm internalSash  = null; 
    
    private Table tableClassificazioni = null;
    private TableViewer tbvClassificazioni = null;
    
    
    private List<String> theClassifications =null;
    private ServiceAssembly sa = null;
    
    private boolean dialogStatus = true;
    private String dialogStatusMsg = "";
    
    public static final String MODE_PUBLISH_NEW_SERVICE = "MODE_NEW_ITERTYPE";
    public static final String MODIFY_SERVICE_CLASSIFICATION = "MODE_MODIFY_ITERTYPE";
    
    private String dialogMode = MODE_PUBLISH_NEW_SERVICE;
    
    
	public PublishServiceRegistryDialog(Shell parentShell, ServiceAssembly sa, String mode) {
		
		super(parentShell);
		
		this.sa = sa;
		this.dialogMode = mode;
		
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
	    if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){
	    	setTitle("Publish Process in ServiceRegistry");
	    	setMessage("The service is not present in service registry you need to publish ");
	    }else if (this.dialogMode.equalsIgnoreCase(MODIFY_SERVICE_CLASSIFICATION)){
	    	setTitle("Modify Classifications of the Process  ");
	    	setMessage("The Process is already published in Service Registry, but you can change classification ");
	    }
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       	
  
		
		aComposite = new Composite(internalSash, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 10;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	// Riga 1
    	serviceOrganizationLabel = new CLabel(aComposite, SWT.RIGHT);
    	if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){ 
    		serviceOrganizationLabel.setText(" Select Organization ");
    	}else{
    		serviceOrganizationLabel.setText(" Organization ");
    	}
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	
    	if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){ 
    		aComboOrganizations = new Combo(aComposite, SWT.READ_ONLY);
        	this.organizations = CimeroEditorPlugin.getDefault().getOrganizations();
    		this.aComboOrganizationItems = new String[organizations.size()];
    		aComboOrganizationItems  = organizations.toArray(aComboOrganizationItems);
    		aComboOrganizations.setItems(aComboOrganizationItems);
    		aComboOrganizations.setLayoutData(data);
    	}else{
    		CLabel labelOrganization =  new CLabel(aComposite, SWT.LEFT);
    		labelOrganization.setText(sa.getUddiOrg());
    		labelOrganization.setLayoutData(data);
    	}
    	CLabel filler = new CLabel(aComposite,SWT.RIGHT);
    	filler.setText(" ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 5;
    	filler.setLayoutData(data);
    	
    	
    	
    	// Riga 2
    	serviceRegistryNameLabel = new CLabel(aComposite, SWT.RIGHT);
    	serviceRegistryNameLabel.setText(" Publish in Registry as ");
    	
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){ 
    		serviceRegistryNameTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    		serviceRegistryNameTextField.setLayoutData(data);
    		serviceRegistryNameTextField.setEditable(false);
    		serviceRegistryNameTextField.setText(sa.getName());
    		
    	}else{
    		CLabel labelRegistryName =  new CLabel(aComposite, SWT.LEFT);
    		labelRegistryName.setText(sa.getUddiName());
    		labelRegistryName.setLayoutData(data);
    	}
    	filler = new CLabel(aComposite,SWT.RIGHT);
    	filler.setText(" ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 5;
    	filler.setLayoutData(data);
    	
//    	 Riga 2
    	serviceDescriptionLabel = new CLabel(aComposite, SWT.RIGHT);
    	serviceDescriptionLabel.setText(" Description ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){ 
    		serviceDescriptionTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    		serviceDescriptionTextField.setLayoutData(data);
    		serviceDescriptionTextField.setEditable(false);
    		serviceDescriptionTextField.setText(sa.getName());
    	}else{
    		CLabel labelRegistryDescr =  new CLabel(aComposite, SWT.LEFT);
    		labelRegistryDescr.setText(sa.getDescription());
    		labelRegistryDescr.setLayoutData(data);
    	}
    	filler = new CLabel(aComposite,SWT.RIGHT);
    	filler.setText(" ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 5;
    	filler.setLayoutData(data);
    	
  
        this.serviceClassificationLabel = new CLabel(aComposite,  SWT.RIGHT);
        serviceClassificationLabel.setText(" Taxonomy ");
        aComboTaxonomies = new Combo(aComposite, SWT.READ_ONLY);
        data = new GridData(GridData.FILL_HORIZONTAL);
        data.widthHint = 200;
    	data.horizontalSpan = 4;
    	this.taxonomies = CimeroEditorPlugin.getDefault().getTaxonomies();
    	this.aComboTaxonomyItems = new String[taxonomies.size()];
    	aComboTaxonomyItems  = taxonomies.toArray(aComboTaxonomyItems);
    	aComboTaxonomies.setItems(aComboTaxonomyItems);
    	aComboTaxonomies.setLayoutData(data);
       
    	
    	aComboTaxonomiesValues = new Combo(aComposite, SWT.READ_ONLY);
    	data = new GridData(GridData.FILL_HORIZONTAL);
        data.widthHint = 200;
    	data.horizontalSpan = 4;
    	this.taxonomiesValues = new ArrayList<String>();
    	this.aComboTaxonomyValuesItems = new String[taxonomiesValues.size()];
    	aComboTaxonomyValuesItems  = taxonomiesValues.toArray(aComboTaxonomyValuesItems);
    	aComboTaxonomiesValues.setItems(aComboTaxonomyValuesItems);
    	aComboTaxonomiesValues.setLayoutData(data);
    	
    	Button btnAddClassification = new Button(aComposite, SWT.FLAT);
    	btnAddClassification.setText(" Add Class. ");
    	
    	final PublishServiceRegistryDialog theDialog = this;
    	final Combo theCombo = this.aComboTaxonomies;
    	this.aComboTaxonomies.addSelectionListener(new SelectionAdapter() {    		
            public void widgetSelected(SelectionEvent event) {                   
            	String taxonomy = theCombo.getText();
            	System.out.println(" Selected Taxonomy "+ taxonomy );
            	theDialog.taxonomiesValues = CimeroEditorPlugin.getDefault().getTaxonomyValues(taxonomy);
            
            	theDialog.aComboTaxonomyValuesItems = new String[taxonomiesValues.size()];
            	theDialog.aComboTaxonomyValuesItems  = theDialog.taxonomiesValues.toArray(theDialog.aComboTaxonomyValuesItems);
            	theDialog.aComboTaxonomiesValues.setItems(theDialog.aComboTaxonomyValuesItems);
            }
    	});
         
    	btnAddClassification.addListener(SWT.Selection, 
    		new Listener() {
            	public void handleEvent(Event event) {
            		String taxonomy = theDialog.aComboTaxonomies.getText();
            		String taxValue = theDialog.aComboTaxonomiesValues.getText();
            		if (   (taxonomy == null) 
            			|| (taxonomy.trim().length() == 0)
            			|| (taxValue == null) 
            			|| (taxValue.trim().length() == 0)){
            			
            			MessageDialog.openInformation(
								getShell(),
								"CimeroEditor Plug-in",
								"To Classify The Service Select a Taxonomy and a taxonomy value");
            		}else{
            			String clsString = taxonomy + ";" + taxValue;
            			if (theClassifications.contains(clsString)){
            				MessageDialog.openInformation(
    								getShell(),
    								"CimeroEditor Plug-in",
    								"This service is already Classified as ["+taxonomy+"]["+taxValue+"]");
            			}else{
            				theDialog.theClassifications.add(clsString);
            				tbvClassificazioni.refresh();
            			}
            		}
            	}       
            });
       
    	// Finito inserimento parte Sopra
    	if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){
    		this.theClassifications = new ArrayList<String>();
    	}else{
    		this.theClassifications = CimeroEditorPlugin.getDefault().getClassificationForService(sa);
    	}
    	
        this.tableClassificazioni = new Table(internalSash, SWT.MULTI | SWT.FULL_SELECTION);
        this.tableClassificazioni.setLinesVisible(true);
        this.tableClassificazioni.setHeaderVisible(true);
        TableColumn column = null;
		column = new  TableColumn(tableClassificazioni, SWT.LEFT);
		column.setText("Taxonomy");
		column.setWidth(200);
		column = new TableColumn(tableClassificazioni, SWT.LEFT);
		column.setText("Classification ");
		column.setWidth(200);
        this.tbvClassificazioni = new TableViewer(tableClassificazioni);
        tbvClassificazioni.setContentProvider(new ClassificationContentProvider());
        tbvClassificazioni.setLabelProvider(new ClassificationLabelProvider());
        tbvClassificazioni.setInput(this.theClassifications);    
    	
        
        this.tableClassificazioni.addKeyListener(new KeyListener(){
        	public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
        		System.out.println("KeyCode =" +  e.keyCode);
        		if (e.keyCode == 127){
        			TableItem[] tis = theDialog.tableClassificazioni.getSelection();
        		
        			
        				for (int i=0; i < tis.length; i++){
        					theDialog.theClassifications.remove(tis[i].getData());
        				}
        			
        			theDialog.tbvClassificazioni.refresh();
        		}
        	};
        	public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
        		
        	};
        	
        });
    	// Weight Settings on Sash
    	internalSash.setWeights(new int[] {45,55});
        return parent; 
	
	}
	
	protected void okPressed() {
		if (this.dialogMode.equalsIgnoreCase(MODE_PUBLISH_NEW_SERVICE)){
			if (serviceRegistryNameTextField.getText().trim().length() <= 0){
				MessageDialog.openInformation(
						getShell(),
						"CimeroEditor Plug-in",
						"To Publish a Service in a Service Registry the Service Name is required");
			}
			
			if 		((aComboOrganizations.getText() == null) 
				||  (aComboOrganizations.getText().trim().length() == 0)){
				MessageDialog.openInformation(
						getShell(),
						"CimeroEditor Plug-in",
						"To Publish a Service you must select an Organization");
			}
			
			try{
				this.dialogStatus = registerInServiceRegistry();
				this.dialogStatusMsg = " Publish of the Service in Service Registry is ok";
			}catch (Exception e) {
				e.printStackTrace();
				this.dialogStatusMsg = "An Exception is occured publishing the Process in Business Register ["+ e.getMessage() +"]";
				
			}
		}else if (this.dialogMode.equalsIgnoreCase(MODIFY_SERVICE_CLASSIFICATION)){
			try{
				this.dialogStatus = reclassifyService();
				this.dialogStatusMsg = "Service Riclassification is ok";
			}catch (Exception e) {
				e.printStackTrace();
				this.dialogStatusMsg = "An Exception is occured during Process Riclassification ["+ e.getMessage() +"]";
			}
		}
		super.okPressed();
		
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
		if (buttonId == IDialogConstants.CANCEL_ID){
			this.dialogStatusMsg = "Operation Cancelled";
			close();
		}
		super.buttonPressed(buttonId);
	}




	public boolean reclassifyService() {
		IServiceRegistry serviceRegistry =  null;
		try{
			serviceRegistry = CimeroEditorPlugin.getDefault().getServiceRegistry();
			serviceRegistry.initRegistry();
			Organization org = serviceRegistry.getOrganizationByName(sa.getUddiOrg());
			Service serviceInRegistry =  serviceRegistry.getServiceByOrganizationNameAndServiceName(sa.getUddiOrg(), sa.getName());
			
			serviceRegistry.removeAllClassificationForService(serviceInRegistry);
			
			String[] taxValue = null;
			ClassificationScheme cScheme = null;
			for (String clsString : this.theClassifications){
				taxValue = clsString.split(";");
				cScheme = serviceRegistry.getClassificationSchemeByName(taxValue[0]);
				serviceRegistry.classifyServiceByTaxonomy(serviceInRegistry, cScheme, taxValue[1]);
			}
			return true;
		}catch(Throwable e){
			this.dialogStatusMsg =  "An Exception is occured publishing the Process in Business Register ["+ e.getMessage() +"]";
			return false;
		}finally{
			serviceRegistry.finalizeRegistry();
		}
	}
	public boolean registerInServiceRegistry() {
		String organization = aComboOrganizations.getText();
		String serviceName = serviceRegistryNameTextField.getText();
		String serviceDescription = serviceRegistryNameTextField.getText();
		
		IServiceRegistry serviceRegistry =  null;
		IMetadbApi metadbApi = CimeroEditorPlugin.getDefault().getMetadbApi();
		try{
			metadbApi.openTx();
			this.sa = metadbApi.getServiceAssemblyByName(sa.getName());
			serviceRegistry = CimeroEditorPlugin.getDefault().getServiceRegistry();
			serviceRegistry.initRegistry();
			

			
			Organization org = serviceRegistry.getOrganizationByName(organization);
		
			Service serviceInRegistry = serviceRegistry.newService(serviceName, serviceDescription);
			
			List<ServiceBinding> bindings = new ArrayList<ServiceBinding>();
			List l = metadbApi.getEndpointsForServiceAssembly(sa);
			
			Endpoint ep = null; 
			for (Iterator it = l.iterator(); it.hasNext();){
				ep = (Endpoint)it.next();
				if (ep.isIsStart()){
					Property locationProp = metadbApi.getEndpointProperty(ep, "accessPoint");
					if (locationProp != null ){
						String location = locationProp.getValue();
						ServiceBinding binding = serviceRegistry.newServiceBinding(serviceName, location);
						bindings.add(binding);
					}
					
				}
			}
			
			serviceInRegistry = serviceRegistry.publishService(org, serviceInRegistry, bindings);
			sa.setUddiOrg(org.getName().getValue());
			sa.setUddiName(serviceName);
			metadbApi.storeServiceAssembly(sa);
			
			String[] taxValue = null;
			ClassificationScheme cScheme = null;
			for (String clsString : this.theClassifications){
				taxValue = clsString.split(";");
				cScheme = serviceRegistry.getClassificationSchemeByName(taxValue[0]);
				serviceRegistry.classifyServiceByTaxonomy(serviceInRegistry, cScheme, taxValue[1]);
			}
			
			metadbApi.commitAndClose();
			return true;
		
		}catch(Throwable e){
		
			metadbApi.rollBackAndClose();
			this.dialogStatusMsg =  "An Exception is occured publishing the Process in Business Register ["+ e.getMessage() +"]";
			return false;
		
		}finally{
			
			serviceRegistry.finalizeRegistry();
		
		}
	}
	
	




	public boolean isDialogStatus() {
		return dialogStatus;
	}




	public void setDialogStatus(boolean dialogStatus) {
		this.dialogStatus = dialogStatus;
	}




	public String getDialogStatusMsg() {
		return dialogStatusMsg;
	}




	public void setDialogStatusMsg(String dialogStatusMsg) {
		this.dialogStatusMsg = dialogStatusMsg;
	}
	
}
