package it.eng.cimero.plugin.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import cimeroEditor.CimeroEditorPlugin;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = CimeroEditorPlugin.getDefault()
				.getPreferenceStore();
		store.setDefault(PreferenceConstants.P_AUDIT_DB_URL, "jdbc:mysql://localhost:3306/smx");
		store.setDefault(PreferenceConstants.P_AUDIT_DB_DRIVER, "com.mysql.jdbc.Driver");
		store.setDefault(PreferenceConstants.P_AUDIT_DB_HIB_DIALECT, "org.hibernate.dialect.MySQLInnoDBDialect");
		store.setDefault(PreferenceConstants.P_AUDIT_DB_USER, "smx");
		store.setDefault(PreferenceConstants.P_AUDIT_DB_PASSWORD, "smx");
		store.setDefault(PreferenceConstants.P_AUDIT_DB_SHOW_SQL, "true");
		
		store.setDefault(PreferenceConstants.P_SERVICE_REGISTRY_INQUIRY_URL, "http://localhost:8080/juddi/inquiry");
		store.setDefault(PreferenceConstants.P_SERVICE_REGISTRY_PUBLISH_URL, "http://localhost:8080/juddi/publish");

		// User to use to connect to service registry
		store.setDefault(PreferenceConstants.P_SERVICE_REGISTRY_USER, "eng");
		
		// Password to use to connect to service registry
		store.setDefault(PreferenceConstants.P_SERVICE_REGISTRY_PASSWORD, "eng");
		
		// Default Organization where to publish services
		store.setDefault(PreferenceConstants.P_SERVICE_REGISTRY_DEFAULT_ORG, "Engineering");
		
		store.setDefault(PreferenceConstants.P_GRAPH_VIZ_DOT_EXE, "C:/Programmi/ATT/Graphviz/bin/dot");
		
		store.setDefault(PreferenceConstants.P_GRAPH_VIZ_TEMP_FOLDER,"C:/tmp");
		
		store.setDefault(PreferenceConstants.P_SMX_GET_RESOURCES, "http://localhost:9092/getResources/");
	}

}
